from torch.utils.data import DataLoader
from data_loader import TestData
import torch
import matplotlib.pyplot as plt
import numpy as np
import pandas as pd


device = torch.device("cuda:0" if torch.cuda.is_available() else "cpu")
# 加载数据
testData = TestData()
genTestData = DataLoader(testData, batch_size=1)
# 加载模型
#model = torch.load('Best_transformer.pkl')
model = torch.load('transformer.pkl')
model.to(device)
model.to(device)
model.eval()
# 开始测试
pred = []
tagt = []

with torch.no_grad():
    for i, (en, de, tg) in enumerate(genTestData):
        change_signal = len(pred)
        if change_signal % 1 == 0:
            out = model(en.to(device), de.to(device))
            start = en
        else:
            ago = start[:, 1:, :]  # 除去第一列
            new = en[:, -1:, :]  # 新的后一列
            start = torch.cat([ago, new], dim=1)
            start[:, -1, -1] = out[0].view(-1)
            out = model(start.to(device), de.to(device))
        pred.append(out[0].item())
        tagt.append(tg.item())


# 结果保存
result_target = np.array(tagt).squeeze()
result_target = np.where(result_target < 0.012, 0, result_target)

result_pred = np.array(pred).squeeze()
result_pred = np.where(result_pred < 0.012, 0, result_pred)

results = {'target': result_target, 'pred': result_pred }
df = pd.DataFrame(results)
df.to_excel('result.xlsx', index=False)
# 计算MAPE
diff = np.abs(result_target - result_pred)
print('MAPE_indicator: ', np.sum(diff))
# 画图
plt.figure(figsize=(10, 5))
plt.plot(np.array(tagt).squeeze())
plt.plot(np.array(pred).squeeze())
plt.legend(['gnd', 'pred'])
plt.show()